//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "testPowerInfoUnit.h"
#include "powrprof.part.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------

PROCCallNtPowerInformation pCallNtPowerInformation=NULL;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
  Grid->Cells[0][0]="BatteryStatus";
  Grid->Cells[1][0]="Value";
  Grid->Cells[0][1]="AcOnLine";
  Grid->Cells[0][2]="BatteryPresent";
  Grid->Cells[0][3]="Charging";
  Grid->Cells[0][4]="Discharging";
  Grid->Cells[0][5]="Spare1[0]";
  Grid->Cells[0][6]="Spare1[1]";
  Grid->Cells[0][7]="Spare1[2]";
  Grid->Cells[0][8]="Spare1[3]";
  Grid->Cells[0][9]="MaxCapacity";
  Grid->Cells[0][10]="RemainingCapacity";
  Grid->Cells[0][11]="Rate";
  Grid->Cells[0][12]="EstimatedTime";
  Grid->Cells[0][13]="DefaultAlert1";
  Grid->Cells[0][14]="DefaultAlert2";

  Grid->Cells[2][0]="CPU Info";
  Grid->Cells[3][0]="Value";
  Grid->Cells[2][1]="Number";
  Grid->Cells[2][2]="MaxMhz";
  Grid->Cells[2][3]="CurrentMhz";
  Grid->Cells[2][4]="MhzLimit";
  Grid->Cells[2][5]="MaxIdleState";
  Grid->Cells[2][6]="CurrentIdleState";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer2Timer(TObject *Sender)
{
  if(pCallNtPowerInformation==NULL)
  {
    HMODULE hDLL=LoadLibrary("powrprof.dll");
    if(hDLL!=NULL)
    {
      pCallNtPowerInformation=(PROCCallNtPowerInformation)
        GetProcAddress(hDLL,"CallNtPowerInformation");
      if(pCallNtPowerInformation==NULL)
      {
        FreeLibrary(hDLL);
      }
    }
  }

  if(pCallNtPowerInformation==NULL)  return;

  LONG Result;
  SYSTEM_BATTERY_STATE BData;
  Result=pCallNtPowerInformation(SystemBatteryState,NULL,0,&BData,sizeof(BData));
  if(Result==STATUS_ACCESS_DENIED)
  {
    for(int i=1;i<15;i++)
      Grid->Cells[1][i]="ACCESS_DENIED";
  }
  else if(Result==STATUS_BUFFER_TOO_SMALL)
  {
    for(int i=1;i<15;i++)
      Grid->Cells[1][i]="BUFFER_TOO_SMALL";
  }
  else
  {
    Grid->Cells[1][1]=BData.AcOnLine;
    Grid->Cells[1][2]=BData.BatteryPresent;
    Grid->Cells[1][3]=BData.Charging;
    Grid->Cells[1][4]=BData.Discharging;
    Grid->Cells[1][5]=BData.Spare1[0];
    Grid->Cells[1][6]=BData.Spare1[1];
    Grid->Cells[1][7]=BData.Spare1[2];
    Grid->Cells[1][8]=BData.Spare1[3];
    Grid->Cells[1][9]=BData.MaxCapacity;
    Grid->Cells[1][10]=BData.RemainingCapacity;
    Grid->Cells[1][11]=BData.Rate;
    Grid->Cells[1][12]=BData.EstimatedTime;
    Grid->Cells[1][13]=BData.DefaultAlert1;
    Grid->Cells[1][14]=BData.DefaultAlert2;
  }
  PROCESSOR_POWER_INFORMATION PData;
  Result=pCallNtPowerInformation(ProcessorInformation,NULL,0,&PData,sizeof(PData));
  if(Result==STATUS_ACCESS_DENIED)
  {
    for(int i=1;i<7;i++)
      Grid->Cells[3][i]="ACCESS_DENIED";
  }
  else if(Result==STATUS_BUFFER_TOO_SMALL)
  {
    for(int i=1;i<7;i++)
      Grid->Cells[3][i]="BUFFER_TOO_SMALL";
  }
  else
  {
    Grid->Cells[3][1]=PData.Number;
    Grid->Cells[3][2]=PData.MaxMhz;
    Grid->Cells[3][3]=PData.CurrentMhz;
    Grid->Cells[3][4]=PData.MhzLimit;
    Grid->Cells[3][5]=PData.MaxIdleState;
    Grid->Cells[3][6]=PData.CurrentIdleState;
  }
}
//---------------------------------------------------------------------------

